clear;

% set some parameters
c0 = 5;         % initial guess for consumption
w0 = 80;        % initial wealth
rho = (1+0.05); % 1 + r
T = 40;         % number of periods
% probability of dying in year t | given alive at start
q = (exp(exp(-6)/0.1*(1-exp(0.1*(2:T+2)))) - ...
     exp(exp(-6)/0.1*(1-exp(0.1*(1:T+1))))) ./ ...
    exp(exp(-6)/0.1*(1-exp(0.1*(1:T+1)))); 
z = 2*ones(1,T+1); % annuty payments
delta = 0.97; % discount factor
g = zeros(1,T+1); % guarantee payment if die
for t=5:-1:1
  g(t) = g(t+1)+z(t);
end
gam = 3;  % u(c) = c^(1-gam)/(1-gam)
bgam = 3; % v(b) = b^(1-bgam)/(1-bgam)
zeta = 1; 
beta = exp(9.9); % weight on bequests

profile on;
for reps=1:100 % repeat to get accurate timing
  [cMatlab fMatlab] = fminbnd(@(c) -vc0(c,w0,rho,q,z,delta,gam,beta,g,bgam,zeta) ...
                            , 0.1, 0.9*w0);

  [cC fC] =  fminbnd(@(c) -vfc1(c,w0,rho,q',z',delta,gam,beta,g',bgam,zeta) ...
                   , 0.1, 0.9*w0);
end

profile viewer;

