#include "mex.h" /* header file for matlab API */

/* function declarations  - needed so we can use them in main() */
unsigned int fibLoop(unsigned int); 

void mexFunction
( 
 int nlhs, /* number of left hand side arguments */
 mxArray *plhs[], /* pointer to lhs*/
 int nrhs, /* number of rhs arguments*/
 const mxArray *prhs[]) /* pointer to rhs arguments*/
{
  int n;
  if (mxGetNumberOfElements(prhs[0])!=1) {
    mexPrintf("Only scalar input allowed\n");
    plhs[0] = mxCreateDoubleScalar(mxGetNaN());
    return;
  }
  n = mxGetScalar(prhs[0]);
  if (n<0 || n!=mxGetScalar(prhs[0])) {
    mexPrintf("Only non-negative integers allowed\n");
    plhs[0] = mxCreateDoubleScalar(mxGetNaN());
    return;
  }
  plhs[0] = mxCreateDoubleScalar(fibLoop(n));
}

unsigned int fibLoop(unsigned int n) {
  unsigned int F,Fm1,Fm2;
  int i;
  
  if (n<=1) return(n);
  Fm1=1;
  Fm2=0;
  for(i=2; i<=n; i++) {
    F = Fm2+Fm1;
    Fm2 = Fm1;
    Fm1 = F;
    /* mexPrintf("Fib number %d is %d\n", i, F);        */
    mexPrintf("Ratio F_n/F_n-1 is %.16g\n", (1.00*Fm1/Fm2));
  }
  return(F);
}
