#include "mex.h" /* header file for matlab API */

/* function declarations  - needed so we can use them in main() */
unsigned int fibFastRecur(unsigned int); 

void mexFunction
( 
 int nlhs, /* number of left hand side arguments */
 mxArray *plhs[], /* pointer to lhs*/
 int nrhs, /* number of rhs arguments*/
 const mxArray *prhs[]) /* pointer to rhs arguments*/
{
  /* error checking omitted */
  plhs[0] = mxCreateDoubleScalar(fibRecur(mxGetScalar(prhs[0])));
}

/* Algorithm taken from Dijkstra (1978) 
   See http://en.wikipedia.org/wiki/Fibonacci_number#cite_note-dijkstra78-7
 */
unsigned int fibFastRecur(unsigned int n) {
  if (n<=1) return(n);
  else if (n%2==0) {
    unsigned int halfn = n/2;
    unsigned int Fhalfn = fibFastRecur(halfn);
    unsigned int Fhalfnp1 = fibFastRecur(halfn+1);
    return(Fhalfn*Fhalfn + Fhalfnp1*Fhalfnp1);
  } else {
    unsigned int halfn = (n-1)/2;
    unsigned int Fhalfn = fibFastRecur(halfn);
    unsigned int Fhalfnp1 = fibFastRecur(halfn+1);
    return((2*Fhalfn+Fhalfnp1)*Fhalfnp1);
  }
}
