#include "mex.h" /* header file for matlab API */

/* function declarations  - needed so we can use them in main() */
unsigned int fibLoop(unsigned int); 

void mexFunction
( 
 int nlhs, /* number of left hand side arguments */
 mxArray *plhs[], /* pointer to lhs*/
 int nrhs, /* number of rhs arguments*/
 const mxArray *prhs[]) /* pointer to rhs arguments*/
{
  /* error checking omitted */
  plhs[0] = mxCreateDoubleScalar(fibLoop(mxGetScalar(prhs[0])));
}

unsigned int fibLoop(unsigned int n) {
  unsigned int F,Fm1,Fm2;
  int i;
  
  if (n<=1) return(n);
  Fm1=1;
  Fm2=0;
  for(i=2; i<=n; i++) {
    F = Fm2+Fm1;
    Fm2 = Fm1;
    Fm1 = F;
  }
  return(F);
}
