unsigned int fibLoop(unsigned int n) {
  unsigned int F,Fm1,Fm2;
  int i;
  
  if (n<=1) return(n);
  Fm1=1;
  Fm2=0;
  for(i=2; i<=n; i++) {
    F = Fm2+Fm1;
    Fm2 = Fm1;
    Fm1 = F;
  }
  return(F);
}

unsigned int fibRecur(unsigned int n) {
  if (n<=1) return(n);
  else return(fibRecur(n-1) + fibRecur(n-2));
}

/* Algorithm taken from Dijkstra (1978) 
   See http://en.wikipedia.org/wiki/Fibonacci_number#cite_note-dijkstra78-7
 */
unsigned int fibFastRecur(unsigned int n) {
  if (n<=1) return(n);
  else if (n==2) return(1);
  else if (n%2==0) {
    unsigned int halfn = n/2;
    unsigned int Fhalfnm1 = fibFastRecur(halfn-1);
    unsigned int Fhalfnp1 = fibFastRecur(halfn+1);
    return(Fhalfnp1*Fhalfnp1 - Fhalfnm1*Fhalfnm1);
  } else {
    unsigned int halfn = (n-1)/2;
    unsigned int Fhalfn = fibFastRecur(halfn);
    unsigned int Fhalfnp1 = fibFastRecur(halfn+1);
    return(Fhalfn*Fhalfn + Fhalfnp1*Fhalfnp1);
  }
}
