#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifdef OMP
#include <omp.h>
#endif

int main (int argv, char *argc[]) {
  int n; 
  double *x;
  int j;
  sscanf(argc[1],"%d",&n);
  x = malloc(n*sizeof(double));
    
#pragma omp parallel default(shared)   
  {
#ifdef OMP
    int tid = omp_get_thread_num();
    if (tid==0) printf("%d threads\n",omp_get_num_threads());
    printf("thread %d says hello\n",tid);
#endif
#pragma omp for
    for(j = 0; j < n; j++) { 
#ifdef OMP
      printf("thread %d working on %d\n",tid,j);      
#endif
      x[j] = log((double) j) - sqrt((double) j);
    }
  } /* end parallel region */
  return(0);
}
