#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <pthread.h>

typedef struct {
  double *x;
  int start;
  int end;
  int tid;
} subarray;

void *threadFn(void *in) {
  subarray *x = (subarray *) in;
  int j;
  for(j = x->start;j<x->end;j++) {
    printf("thread %d working on %d\n",x->tid,j);      
    x->x[j] = log((double) j) - sqrt((double) j);
  }
  return(NULL);
}

int main (int argv, char *argc[]) {
  int n; 
  double *x;
  int j;
  int nthread = 1;
  pthread_t *thr;
  subarray *s;
  sscanf(argc[1],"%d",&n);
  if (argv>2) sscanf(argc[2],"%d",&nthread);
  x = malloc(n*sizeof(double));
  s = malloc(nthread*sizeof(subarray));
  thr = malloc(nthread*sizeof(pthread_t));
  
  for(j=0;j<nthread;j++) {
    s[j].x = x;
    s[j].tid = j;
    s[j].start = j*(n/nthread);
    s[j].end = j==(nthread-1)? n:(j+1)*(n/nthread);
    pthread_create(thr+j,NULL,threadFn,(void*) &s[j]);
  }
  for(j=0;j<nthread;j++) pthread_join(thr[j],NULL);
  free(thr);
  free(s);

  return(0);
}
