/* 
   Paul Schrimpf
   May 30, 2008
   Plugin for stata that does regression
   See http://www.stata.com/plugins/ for more info  
*/
#include <stdlib.h>
#include <stdio.h>
#include "stplugin.h"

void reg(double *beta, double *y, double **x, int n, int k);

STDLL stata_call(int argc, char *argv[]) 
{
  ST_int  i, j,  k;
  double **x,*y,*beta;
  char buf[100];
  /* allocate */
  SF_display("0");
  y = calloc(SF_nobs(),sizeof(double));
  SF_display("1");
  x = calloc(SF_nobs(),sizeof(double*));
  SF_display("2");
  x[0] = calloc(SF_nvars()*SF_nobs(),sizeof(double));
  for(i=1;i<SF_nobs();i++) x[i] = x[i-1]+SF_nvars();
  SF_display("3");
  beta = calloc(SF_nvars(),sizeof(double));
  
  /* get data from stata */
  i = 0;
  for(j = SF_in1(); j <= SF_in2(); j++) { 
    /* loop from first to last observation in range */ 
    if(SF_ifobs(j)) { /* true if stata if command true */
      SF_vdata(1,j,y+i); 
      for(k=2;k<=SF_nvars();k++) SF_vdata(k,j,x[i]+k-2); 
      i++;
    }
  }
  SF_display("4\n");

  reg(beta,y,x,i,(int) SF_nvars()-1);
  /* print results */
  for(k=0;k<SF_nvars()-1;k++) {
    sprintf(buf,"%.8g\n",beta[k]);
    SF_display(buf);
  }
  free(x[0]);
  free(x);
  free(y);
  free(beta);
  return(0);
}

void reg(double *beta, double *y, double **x, int n, int k)
{
  int i,j,l;
  double *xy; /* x'y  */
  double *xx; /* x'x laid out columnwise ala Matlab */
  
  xy = calloc(k,sizeof(double));
  xx = calloc(k*k,sizeof(double));
  
  for(j=0;j<k;j++) {
    for(i=0;i<n;i++) xy[j] += x[i][j]*y[i];
    for(l=0;l<k;l++) {
      for(i=0;i<n;i++) xx[j+l*k] += x[i][j]*x[i][l];
    }
  }
  if (k==1) beta[0] = xy[0]/xx[0];
  else printf("k>1 not implemented\n");
  printf("beta[0] = %.16g, %g, %g\n",beta[0],xy[0],xx[0]);
}
    
