% script comparing randTruncNormal() to inverse cdf method
clear;

N = 100; % how many draws each time
R = 1000; % how many repetitions
mu = rand(N,1);  % mean
var = rand(N,1); % variance
lo = rand(N,1)-1; % low truncation point
hi = rand(N,1)+1;  % high truncation point

x = zeros(N,1); % preallocate output array

% matlab version
tic;
for r=1:R
  lcdf = cdf('norm',lo,mu,var);
  hcdf = cdf('norm',hi,mu,var);
  x = icdf('norm',lcdf+rand(N,1).*(hcdf-lcdf),mu,var);
end
toc

% c version
tic
for r=1:R
  x = randTruncNormal(mu,var,lo,hi);
end
toc
